#ifndef _Rig_H
#define _Rig_H

#include <string>
#include <sys/types.h>
#include <pthread.h>

#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Enumerations.H>

#ifndef WIN32
#include <unistd.h>
#include <pwd.h>
#endif

#include <FL/fl_ask.H>
#include <FL/Fl_File_Chooser.H>
#include <FL/Fl_Color_Chooser.H>
#include <FL/fl_draw.H>

#ifndef BUILD_CONFIGURE_ARGS
#	include <config.h>
#endif

extern Fl_Double_Window *mainwindow;

extern pthread_t       *client_thread;
extern pthread_mutex_t mutex_xmlrpc;
extern pthread_mutex_t mutex_client;

extern void *client_thread_loop(void *d);
extern void  client_start_thread();
extern void  client_stop_thread();
extern bool  run_client_thread;

extern void  init_commands();

extern void cb_Exit();
extern void about();

extern bool WKEY_DEBUG;

#endif
